SimpleFacets (Solr 3.6.2 API)
Keywords: org.apache.solr.request.SimpleFacets class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.solr.request
Class SimpleFacets

    java.lang.Object
      org.apache.solr.request.SimpleFacets

    public class SimpleFacets

extends Object

A class that generates simple Facet information for a request. More advanced facet implementations may compose or subclass this class to leverage any of it's functionality.

Nested Class Summary
`static class` | `SimpleFacets.CountPair<K extends Comparable<? super K>,V extends Comparable<? super V>>` A simple key=>val pair whose natural order is such that higher vals come before lower vals.

Field Summary
`protected DocSet` | `docs` The main set of documents all facet counts should be relative to
`protected SimpleOrderedMap` | `facetResponse`
`protected SolrParams` | `params` Configuration params behavior should be driven by
`protected ResponseBuilder` | `rb`
`protected SolrQueryRequest` | `req`
`protected SolrParams` | `required`
`protected SolrIndexSearcher` | `searcher` Searcher to use for all calculations

Constructor Summary
`SimpleFacets(SolrQueryRequest req, DocSet docs, SolrParams params)`
`SimpleFacets(SolrQueryRequest req, DocSet docs, SolrParams params, ResponseBuilder rb)`

Method Summary
`NamedList` | `getFacetCounts()` Looks at various Params to determing if any simple Facet Constraint count computations are desired.
`NamedList` | `getFacetDateCounts()` Deprecated. Use getFacetRangeCounts which is more generalized
`void` | `getFacetDateCounts(String dateFacet, NamedList resOuter)` Deprecated. Use getFacetRangeCounts which is more generalized
`NamedList` | `getFacetFieldCounts()` Returns a list of value constraints and the associated facet counts for each facet field specified in the params.
`NamedList` | `getFacetQueryCounts()` Returns a list of facet counts for each of the facet queries specified in the params
`NamedList` | `getFacetRangeCounts()` Returns a list of value constraints and the associated facet counts for each facet numerical field, range, and interval specified in the SolrParams
`NamedList` | `getFacetTermEnumCounts(SolrIndexSearcher searcher, DocSet docs, String field, int offset, int limit, int mincount, boolean missing, String sort, String prefix)` Returns a list of terms in the specified field along with the corresponding count of documents in the set that match that constraint.
`static NamedList` | `getFieldCacheCounts(SolrIndexSearcher searcher, DocSet docs, String fieldName, int offset, int limit, int mincount, boolean missing, String sort, String prefix)` Use the Lucene FieldCache to get counts for each unique field value in `docs`.
`static int` | `getFieldMissingCount(SolrIndexSearcher searcher, DocSet docs, String fieldName)` Returns a count of the documents in the set which do not have any terms for for the specified field.
`NamedList` | `getTermCounts(String field)`
`protected int` | `rangeCount(SchemaField sf, Date low, Date high, boolean iLow, boolean iHigh)` Deprecated. Use rangeCount(SchemaField,String,String,boolean,boolean) which is more generalized
`protected int` | `rangeCount(SchemaField sf, String low, String high, boolean iLow, boolean iHigh)` Macro for getting the numDocs of range over docs

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### docs

    protected DocSet docs

  The main set of documents all facet counts should be relative to

### params

    protected SolrParams params

  Configuration params behavior should be driven by

### required

    protected SolrParams required

### searcher

    protected SolrIndexSearcher searcher

  Searcher to use for all calculations

### req

    protected SolrQueryRequest req

### rb

    protected ResponseBuilder rb

### facetResponse

    protected SimpleOrderedMap facetResponse

Constructor Detail

### SimpleFacets

    public SimpleFacets(SolrQueryRequest req,
                        DocSet docs,
                        SolrParams params)

### SimpleFacets

    public SimpleFacets(SolrQueryRequest req,
                        DocSet docs,
                        SolrParams params,
                        ResponseBuilder rb)

Method Detail

### getFacetCounts

    public NamedList getFacetCounts()

  Looks at various Params to determing if any simple Facet Constraint count computations are desired.

  Returns:
    a NamedList of Facet Count info or null
  See Also:
    `getFacetQueryCounts()`, `getFacetFieldCounts()`, `getFacetDateCounts()`, `getFacetRangeCounts()`, `FacetParams.FACET`

### getFacetQueryCounts

    public NamedList getFacetQueryCounts()
                                  throws IOException,
                                         ParseException

  Returns a list of facet counts for each of the facet queries specified in the params

  Throws:
    `IOException`
    `ParseException`
  See Also:
    `FacetParams.FACET_QUERY`

### getTermCounts

    public NamedList getTermCounts(String field)
                            throws IOException

  Throws:
    `IOException`

### getFacetFieldCounts

    public NamedList getFacetFieldCounts()
                                  throws IOException,
                                         ParseException

  Returns a list of value constraints and the associated facet counts for each facet field specified in the params.

  Throws:
    `IOException`
    `ParseException`
  See Also:
    `FacetParams.FACET_FIELD`, `getFieldMissingCount(org.apache.solr.search.SolrIndexSearcher, org.apache.solr.search.DocSet, java.lang.String)`, `getFacetTermEnumCounts(org.apache.solr.search.SolrIndexSearcher, org.apache.solr.search.DocSet, java.lang.String, int, int, int, boolean, java.lang.String, java.lang.String)`

### getFieldMissingCount

    public static int getFieldMissingCount(SolrIndexSearcher searcher,
                                           DocSet docs,
                                           String fieldName)
                                    throws IOException

  Returns a count of the documents in the set which do not have any terms for for the specified field.

  Throws:
    `IOException`
  See Also:
    `FacetParams.FACET_MISSING`

### getFieldCacheCounts

    public static NamedList getFieldCacheCounts(SolrIndexSearcher searcher,
                                                DocSet docs,
                                                String fieldName,
                                                int offset,
                                                int limit,
                                                int mincount,
                                                boolean missing,
                                                String sort,
                                                String prefix)
                                         throws IOException

  Use the Lucene FieldCache to get counts for each unique field value in `docs`. The field must have at most one indexed token per document.

  Throws:
    `IOException`

### getFacetTermEnumCounts

    public NamedList getFacetTermEnumCounts(SolrIndexSearcher searcher,
                                            DocSet docs,
                                            String field,
                                            int offset,
                                            int limit,
                                            int mincount,
                                            boolean missing,
                                            String sort,
                                            String prefix)
                                     throws IOException

  Returns a list of terms in the specified field along with the corresponding count of documents in the set that match that constraint. This method uses the FilterCache to get the intersection count between `docs` and the DocSet for each term in the filter.

  Throws:
    `IOException`
  See Also:
    `FacetParams.FACET_LIMIT`, `FacetParams.FACET_ZEROS`, `FacetParams.FACET_MISSING`

### getFacetDateCounts

    @Deprecated
    public NamedList getFacetDateCounts()
                                 throws IOException,
                                        ParseException

  Deprecated. Use getFacetRangeCounts which is more generalized

  Returns a list of value constraints and the associated facet counts for each facet date field, range, and interval specified in the SolrParams

  Throws:
    `IOException`
    `ParseException`
  See Also:
    `FacetParams.FACET_DATE`

### getFacetDateCounts

    @Deprecated
    public void getFacetDateCounts(String dateFacet,
                                              NamedList resOuter)
                            throws IOException,
                                   ParseException

  Deprecated. Use getFacetRangeCounts which is more generalized

  Throws:
    `IOException`
    `ParseException`

### getFacetRangeCounts

    public NamedList getFacetRangeCounts()
                                  throws IOException,
                                         ParseException

  Returns a list of value constraints and the associated facet counts for each facet numerical field, range, and interval specified in the SolrParams

  Throws:
    `IOException`
    `ParseException`
  See Also:
    `FacetParams.FACET_RANGE`

### rangeCount

    protected int rangeCount(SchemaField sf,
                             String low,
                             String high,
                             boolean iLow,
                             boolean iHigh)
                      throws IOException

  Macro for getting the numDocs of range over docs

  Throws:
    `IOException`
  See Also:
    `SolrIndexSearcher.numDocs(org.apache.lucene.search.Query, org.apache.solr.search.DocSet)`, `TermRangeQuery`

### rangeCount

    @Deprecated
    protected int rangeCount(SchemaField sf,
                                        Date low,
                                        Date high,
                                        boolean iLow,
                                        boolean iHigh)
                      throws IOException

  Deprecated. Use rangeCount(SchemaField,String,String,boolean,boolean) which is more generalized

  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD